/* hw3.c */

#include <stdio.h>
#include "q.h"
#include "kernel.h"

/*------------------------------------------------------------------------
 *  newqueue  --  initialize a new list in the q structure
 *------------------------------------------------------------------------
 */
int	newqueue()
{
	struct	qent	*hptr;		/* address of new list head	*/
	struct	qent	*tptr;		/* address of new list tail	*/
	int	hindex, tindex;		/* head and tail indexes	*/

	hptr = &q[ hindex=nextqueue++ ];/* nextqueue is global variable	*/
	tptr = &q[ tindex=nextqueue++ ];/*  giving next used q pos.	*/
	hptr->qnext = tindex;
	hptr->qprev = EMPTY;
	hptr->qkey  = MININT;
	tptr->qnext = EMPTY;
	tptr->qprev = hindex;
	tptr->qkey  = MAXINT;
	return(hindex);
}

/*------------------------------------------------------------------------
 *  insert  --  insert a process into a q list in key order
 *------------------------------------------------------------------------
 */
int insert(proc, head, key)
int proc;				/* process to insert		*/
int head;				/* q index of head of list	*/
int key;				/* key to use for this process	*/
{
	int	next;			/* runs through list		*/
	int	prev;

	next = q[head].qnext;
	while (q[next].qkey < key)	/* tail has MAXINT as key	*/
		next = q[next].qnext;
	q[proc].qnext = next;
	q[proc].qprev = prev = q[next].qprev;
	q[proc].qkey  = key;
	q[prev].qnext = proc;
	q[next].qprev = proc;
	return(OK);
}

int printlist( head )
int head;
{

}

int element( head, n )
int head,n;
{

}

int length(head)
int head;
{

}

int reverse(head, tail)
int head, tail;
{

}

int find(proc_id, head)
int proc_id, head;
{

}

int merge(head1, head2)
int head1, head2;
{

}

int find_process(id)
int id;
{

}

main ()
{
  int i;
  int printlist(), element(), length(), reverse(), find(), merge(),
	 find_process();
  int READY_HEAD, SLEEP_HEAD;

  READY_HEAD = newqueue();			/* initialization of      */
  SLEEP_HEAD = newqueue();			/* READY and SLEEP queues */

  printlist( READY_HEAD );
  printlist( SLEEP_HEAD );

  insert(3, READY_HEAD, 10);
  insert(5, READY_HEAD, 15);
  insert(2, READY_HEAD, 5);

  printlist( READY_HEAD );

  i = length( READY_HEAD );
  printf("length of READY list : %d \n", i);

  reverse( READY_HEAD, READY_HEAD+1);
  printlist( READY_HEAD );
  reverse ( READY_HEAD, READY_HEAD+1);
  printlist( READY_HEAD );

  insert(1, SLEEP_HEAD, 10);
  insert(4, SLEEP_HEAD, 7);
  printlist( SLEEP_HEAD );
 
  i = find_process( 1 );
  if (i == READY_HEAD)
	printf("process 1 in READY list\n");
  else
	printf("process 1 in SLEEP list\n");

  i = element(READY_HEAD, length(READY_HEAD));
  printf("The last element in READY list: %d\n", i);

  i = find(i, SLEEP_HEAD);
  if (i != 0) printf("ERROR!\n");

  i = find(4, SLEEP_HEAD);
  if (i != 0) printf("found!\n");

  merge(READY_HEAD, SLEEP_HEAD);

  printlist(SLEEP_HEAD);
  printf("----------------\n");
  printlist(READY_HEAD);
}
