/* shell.c */
 
#include <kernel.h>
#include <proc.h>
#include <conf.h>		/* For getchar */
#include <io.h>			/* For getchar */
 
extern int echo(), stop(), bg(), fg(), term(), integers(),
                letters(), cmdloop(), ( * isin() ) ();
 
typedef struct { char *name;
                 int  (*addr)();
               } command;
 
command builtin[] = { "echo"    , echo ,
                      "stop"    , stop ,
                      "bg"      , bg   ,
                      "fg"      , fg   ,
                      "term"    , term ,
                      (char *)0 , ( int (*) () ) 0  } ;
 
command child[] = { "integers"  , integers ,
                    "letters"   , letters  ,
                    (char *)0   , ( int (*) () ) 0  } ;
 
char prompt[] = "xsh => ";
 
int fg_proc = 0;		/* the foreground process pid, if any */
int shell_pid;
 
xmain()
{
        resume(create(cmdloop,1000,20,"shell",0));
}
 
#define LINELENGTH 80		/* cmd line max length      */
#define CMDLENGTH 20		/* cmd word max length      */
#define CHSTACK 1000		/* child process stack size */
#define CHPRIO  15		/* child process priority   */
 
cmdloop()
{
  ????????????????    		/* Declaration of faddr */
  char prev_line[LINELENGTH];
  char line[LINELENGTH];
  char cmdword[CMDLENGTH];
  int background, cmdarg, cmdpid;
  char *cp;
 
  ?????????????????????    	/* Initialize shell_pid */
	
  ????????????????     		/* Initialize prev_line */
	
  ??????????? 			/* loop */
    {
      printf(prompt);
 
      ????????????????????????????????????????????    	/* read line */
      ?????     = 0;
      if(??????    )		/* Empty line? */
	continue;
 
      if(!strcmp(line, "!!"))	/* history? */
	?????????????????????????
 
      background = ???????     == '&' ;
      if(sscanf(line+??????????    , " %s %d ", ????????????????    ) != 2)
	{
	  printf("Command format error: '%s'\n", line);
	  continue;
	}
		
      if( faddr = isin(builtin,cmdword))	/* if builtin */
	?????????????????    			/* execute it */
      else if ( faddr = isin(child,cmdword) )	/* if child */
	{
	  cmdpid=create(?????????????????????????????????????    );
	  if (??????????????    )
	    {
	      printf("No more processes!\n");
	      ?????????    
	    }
	  ????????????????    	/* Remember foreground process */
	    fg_set(cmdpid);
	  ???????????????    
	  if (background)
	    printf("[%d]\n",cmdpid);
	  else
	    ??????????    	/* Foreground wait for termination or stop*/
	}
      else 
	{
	  ????????????????????????????????????????????    
	  ?????????    
	}
      strcpy(???????????????    );
    }
}
 
fg_set(pid)
int pid;
{
  ???????????   			/* Clear old messages */
  ??????????????    			/* remember fg process */
}
 
fg_wait()
{
  int msg;
  ?????????????????????????????????    	/* wait to next message */;
  fg_proc = 0;
}
 
int ( * isin(cmdlist,name) ) ()	/* is word name in command list cmdlist ?   */
command *cmdlist;               /* if it is, return pointer to function     */
char *name;                     /* returning int                            */
{
  ???????????????????????????????????????????????   
    ???????????????????????????????????????    
  ???????????????????????    
}
 
integers(n)
int n;
{
  int i, j;
 
  for (i=1; i<=n; i++)
    {
      printf("%d\n",i);
      for (j=0;j<30000;j++);
    }
  ??????????????????????????    
}
 
int letters(n)
int n;
{
  int i, j;
  char ch;
 
  for (i=0,ch='a'; i<n; i++,ch++)
    {
      if(ch>'z') ch='a';
      printf("%c\n",ch);
      for (j=0;j<30000;j++);
    }
  ???????????????????????????   
}
 
int echo(n)
int n;
{
  printf("%d\n",n);
}
 
#define check(pid) if (isbadpid(pid) || proctab[pid].pstate==PRFREE) \
                        { printf("No such process\n"); return 0; }
 
int fg(n)
int n;
{
  ???????????   		/* Remember ! */
  check(n);
  if (proctab[n].pstate ??????????????????????   
  ???????????   		/* Foreground wait for termination or stop */
}
 
int bg(n)
int n;
{
  check(n);
  if (proctab[n].pstate ??????????????????????   
}
 
int stop(n)
int n;
{
  check(n);
  if (proctab[n].pstate ???????????????????????    
}
 
int term(n)
int n;
{
  check(n);
  kill(n);
}
 
fg_stop()
{
  if (fg_proc!=0 && ??????????????????????????????????   
    {
      ???????????????????  
      printf("Foreground process [%d] stopped\n", fg_proc);
      ?????????????????????????    
    }
}
