/* az.c - xmain */

#include <conf.h>
#include <kernel.h>
#include <tty.h>


/*----------------------------------------------------------------------------
 * xmain - user process started up at initialization
 *----------------------------------------------------------------------------
 */

/* print A's in one window, Z's in the other */

int	dowin1();
int	dowin2();
int	done1;		/* termination semaphores */
int	done2;

xmain()
{
	done1 = screate(0);
	done2 = screate(0);
	resume(create(dowin1,INITSTK,INITPRIO,"pr1",0));
	resume(create(dowin2,INITSTK,INITPRIO,"pr2",0));
	wait(done1);
	wait(done2);
	xdone();
}

dowin1()
{
	char	ch;
	int	i;
	int	w;

	if ( (w=open(CONSOLE,"0,0:39,24",NULL)) == SYSERR ) {
		kprintf("can't open window 1\n");
		signal(done1);
		return;
	}
	fprintf(w,"window 1 is on device %d\n",w);
	sleep(0);		/* force a reschedule	*/
	ch = 'A';
	for (i=1 ; i<1000 ; i++)
		putc(w,ch);
	sleep(5);
	for (i=0; (ch="\nClosing the left window..."[i]) ; i++ )
		putc(w,ch);
	sleep(3);
	close(w);
	signal(done1);
}

dowin2()
{
	char	ch;
	int	i;
	int	w;

	if ( (w=open(CONSOLE,"#40,0:79,24",NULL)) == SYSERR ) {
		kprintf("can't open window 2\n");
		signal(done2);
		return;
	}
	fprintf(w,"window 2 is on device %d\n",w);
	sleep(0);		/* force a reschedule	*/
	ch = 'Z';
	for (i=1 ; i<1000 ; i++)
		putc(w,ch);
	sleep(10);
	for (i=0; (ch="\nClosing the right window..."[i]) ; i++ )
		putc(w,ch);
	sleep(3);
	close(w);
	signal(done2);
}
