/* mtst.c - xmain */
/* test memory managemet */

#include <kernel.h>
#include <conf.h>
#include <dos.h>
#include <mem.h>

#define MPSIZE	78
#define MULT	29

char *mp[MPSIZE];

xmain()
{
	int	i;
	int	maxi;

	/* print currently available memory */
	printf("%u\n",((MBLOCK *)(memlist.mnext))->mlen);

	/* allocate blocks of increasing size */
	for ( i=0 ; i<MPSIZE ; ) {	
		if ( (mp[i]=getmem(MULT*(i+1))) == NULL )
			break;
		maxi = ++i;
		printf(".");
	}
	printf("\n");

	/* print available memory after allocations */
	printf("%u (%d)\n",((MBLOCK *)(memlist.mnext))->mlen,maxi);

	/* now deallocate odd numbered blocks . . . */
	for ( i=1 ; i<maxi ; i+=2 ) {
		printf(".");
		freemem(mp[i],MULT*(i+1));
	}

	/* . . . and even numbered blocks */
	for ( i=0 ; i<maxi ; i+=2 ) {
		printf(".");
		freemem(mp[i],MULT*(i+1));
	}
	printf("\n");

	/* print available memory after all deallocations */
	printf("%u\n",((MBLOCK *)(memlist.mnext))->mlen);
	xdone();
}
